clear
mu=0;
ruido=0.0;
%
% prob dir
pv=[0.5 1.25]';
x1=0.5;x2=0.5;
dp=0.001;
au=fnl(x1,x2,pv(1),pv(2));
g11=[fnl(x1,x2,pv(1)+dp,pv(2))-au]/dp;
g12=[fnl(x1,x2,pv(1),pv(2)+dp)-au]/dp;
X1=0.5;X2=-0.5;
au=fnl(x1,x2,pv(1),pv(2));
g21=[fnl(X1,X2,pv(1)+dp,pv(2))-au]/dp;
g22=[fnl(X1,X2,pv(1),pv(2)+dp)-au]/dp;

G=[g11 g12;g21 g22];
d=G*pv;
n=length(G(:,1));
dr=ruido*([rand(n,1)-0.5]*2)+d;
% prob inv
P=inv(G'*G+mu*eye(2))*G'*dr;
[U,S,V]=svd(G);
pi=-1;pf=1.75;dp=(pf-pi)/25;
p=[pi:dp:pf]';np=length(p);
Q=zeros(np,np);
R=zeros(np,np);
for i=1:np
    for j=1:np
        pp=[p(j);p(i)];         
        r=d-G*pp;
        Q(i,j)=sqrt(r'*r);
        R(i,j)=sqrt(pp'*pp);
        d1=fnl(x1,x2,p(j),p(i));
        d2=fnl(X1,X2,p(j),p(i));
        r=d-[d1 d2]';
        N(i,j)=sqrt(r'*r);
    end
end
%
%
figure
subplot(121)
contourf(p,p,Q);
xlabel('{p_1}');ylabel('{p_2}')
axis image;shading flat
hold on
h=plot(pv(1),pv(2),'ow',P(1),P(2),'oy');
set(h,'MarkerSize',8)
colorbar
title('{|r|}')
%
h=plot(...
    [0 S(1,1)*V(1,1)],[0 S(1,1)*V(2,1)],'k-',...
    [0 S(2,2)*V(1,2)],[0 S(2,2)*V(2,2)],'w-');set(h,'LineWidth',4)
axis image
axis([pi pf pi pf])
grid on
hold off

subplot(122)
contourf(p,p,N);
xlabel('{p_1}');ylabel('{p_2}')
axis image;shading flat
hold on
h=plot(pv(1),pv(2),'ow',P(1),P(2),'oy');
set(h,'MarkerSize',8)
colorbar
title('{|r|}')
%
h=plot(...
    [0 S(1,1)*V(1,1)],[0 S(1,1)*V(2,1)],'k-',...
    [0 S(2,2)*V(1,2)],[0 S(2,2)*V(2,2)],'w-');set(h,'LineWidth',4)
axis image
axis([pi pf pi pf])
grid on
hold off